namespace eval MiguelPruebas {
    variable _dir
    variable _lista_ogl
    variable _id_func_ogl
    variable _tiene_bug_deletelists

    proc borra_listas_y_registro { } {
	variable _lista_ogl
	variable _id_func_ogl
	variable _tiene_bug_deletelists
	
	foreach t "nodos elementos" {
	    if { $_lista_ogl($t,id) >= 0} {
		if { $_tiene_bug_deletelists} {
		    drawopengl draw -deletelists "$_lista_ogl($t,id) 1"
		} else {
		    drawopengl draw -deletelists $_lista_ogl($t,id) 1
		}
	    }
	    set _lista_ogl($t,id) -1
	}

	if { $_id_func_ogl != -1} {
	    drawopengl unregister $_id_func_ogl
	}
	set _id_func_ogl -1
    }

    proc Ini { dir} {
	variable _dir
	variable _lista_ogl
	variable _id_func_ogl
	variable _tiene_bug_deletelists

	set _dir $dir
	set colores [ list "0.0 0.66666667 0.0" "0.69841 0.190464 0.69841"]
	foreach t "nodos elementos" c $colores {
	    set _lista_ogl($t,id) -1
	    set _lista_ogl($t,color) $c
	}
	set _id_func_ogl -1

	set VersionRequired "7.5.2b" 
	set comp -1
	catch { 
	    set comp [GiDVersionCmp $VersionRequired]
	}
	set _tiene_bug_deletelists 0
	if { $comp < 0 } {
	    set _tiene_bug_deletelists 1
	}
    }

    proc End { } {
	borra_listas_y_registro
    }

    proc WaitState { } {
	::GiDUtils::WaitState .gid
    }
    
    proc EndWaitState { } {
	::GiDUtils::EndWaitState .gid
    }

    proc PintarLista { } {
	variable _lista_ogl

	foreach t "nodos elementos" {
	    if { $_lista_ogl($t,id) >= 0} {
		drawopengl draw -color $_lista_ogl($t,color)
		drawopengl draw -calllist $_lista_ogl($t,id)
	    }
	}
    }

    proc CambiaColor { que} {
	variable _lista_ogl
	
	if { ( $que != "nodos") && ( $que != "elementos")} {
	    return
	}

	set r [ expr int( 0.5 + 255.0 * [ lindex $_lista_ogl($que,color) 0])]
	set g [ expr int( 0.5 + 255.0 * [ lindex $_lista_ogl($que,color) 1])]
	set b [ expr int( 0.5 + 255.0 * [ lindex $_lista_ogl($que,color) 2])]
	set color_viejo [ format "#%02x%02x%02x" $r $g $b]
	::GidUtils::CambiaColor "" color_viejo
	set n [ scan $color_viejo "#%2x%2x%2x" r g b]
	if { $n == 3} {
	    set r [ expr double( $r) / 255.0]
	    set g [ expr double( $g) / 255.0]
	    set b [ expr double( $b) / 255.0]
	    set _lista_ogl($que,color) [ list $r $g $b]
	}
	.gid.central.s render
    }

    proc LeerMalla { } {
	variable _lista_ogl
	variable _id_func_ogl
	variable _tiene_bug_deletelists

	if { [ set fname [ Browser-ramR file read .gid "Import mesh"]] ne ""} {
	    WaitState
	    set n_char [ file size $fname]
	    set i_char 0
	    set i_bar 0
	    set fi [ open $fname]
	    set lst_idx_puntos {}
	    set lst_que_elementos {}
	    set MESH(tipo) ""
	    set n_elems 0
	    AdvanceBar $i_char $n_char $i_char [= "Tcl OpenGL example"] [= "reading $fname"]
	    while { [ set len [ gets $fi linea]] >= 0} {
		incr i_char $len
		incr i_char
		incr i_bar
		if { $i_bar == 10000} {
		    AdvanceBar $i_char $n_char [ expr int( 100.0 * $i_char / $n_char)]
		    set i_bar 0
		}
		if { [ regexp -nocase {^ *MESH .*dimension *=? *[2,3] *Elemtype *=? *([^ ]*) *nnode *=? *([0-9]+)} $linea dum tipo_elem n_nodos]} {
		    set lst_elem [ string tolower "Point Linear Triangle Quadrilateral Tetrahedra Hexahedra Prisma"]
		    set tipo_elem [ string tolower $tipo_elem]
		    set lst_nnodos {{1} {2 3} {3 6} {4 8 9} {4 10} {8 20 27} {6 15}}
		    set idx [ lsearch $lst_elem $tipo_elem]
		    if { ( $idx != -1) && ( [ lsearch [ lindex $lst_nnodos $idx] $n_nodos] != -1)} {
			set MESH(tipo) [ list $tipo_elem $n_nodos]
			lappend lst_que_elementos $MESH(tipo)
			if { ![ info exist MESH($MESH(tipo))]} {
			    set MESH($MESH(tipo)) {}
			}
		    }
		} elseif { [ regexp -nocase {^ *coordinates.*} $linea]} {
		    while { ( [ set len [ gets $fi linea]] >= 0) && ![regexp -nocase {^ *end *coordinates.*} $linea]} {
			incr i_char $len
			incr i_char
			incr i_bar
			if { $i_bar == 10000} {
			    AdvanceBar $i_char $n_char [ expr int( 100.0 * $i_char / $n_char)]
			    set i_bar 0
			}
			if { [ regexp {^ *\#.*} $linea] } {
			    continue
			}
			if { [ llength $linea] == 4} {
			    set idx [ lindex $linea 0]
			    lappend lst_idx_puntos $idx
			    set puntos($idx) "[ lindex $linea 1] [ lindex $linea 2] [ lindex $linea 3]"
			}
		    }
		    if { $len >= 0} {
			incr i_char $len
			incr i_char
			incr i_bar
			if { $i_bar == 10000} {
			    AdvanceBar $i_char $n_char [ expr int( 100.0 * $i_char / $n_char)]
			    set i_bar 0
			}
		    }
		    # break
		    # nada de break por si hay mas coordenadas en otros sitios
		} elseif { [ regexp -nocase {^ *elements.*} $linea]} {
		    if { $MESH(tipo) == ""} {
			continue
		    }
		    set nnodos [ lindex $MESH(tipo) 1]
		    set n_campos_1 [ expr $nnodos + 1]
		    set n_campos_2 [ expr $nnodos + 2]
		    while { ( [ gets $fi linea] >= 0) && ![regexp -nocase {^ *end *elements.*} $linea]} {
			incr i_char $len
			incr i_char
			incr i_bar
			if { $i_bar == 10000} {
			    AdvanceBar $i_char $n_char [ expr int( 100.0 * $i_char / $n_char)]
			    set i_bar 0
			}
			if { [ regexp {^ *\#.*} $linea] } {
			    continue
			}
			set nc [ llength $linea] 
			if { ( $nc == $n_campos_1) || ( $nc == $n_campos_2) } {
			    lappend MESH($MESH(tipo)) [ lrange $linea 1 $nnodos]
			    incr n_elems
			}
		    }
		    if { $len >= 0} {
			incr i_char $len
			incr i_char
			incr i_bar
			if { $i_bar == 10000} {
			    AdvanceBar $i_char $n_char [ expr int( 100.0 * $i_char / $n_char)]
			    set i_bar 0
			}
		    }
		}
	    }
	    close $fi
	    AdvanceBar $n_char $n_char 100
	    set n [ llength $lst_idx_puntos]
	    WarnWin "Read $n points and $n_elems elements."

	    set _list_ogl -1
	    if { $n > 1} {
		# primero borramos la lista, si existe y la funcion por si acaso
		borra_listas_y_registro

		# pedimos a opengl un id para una nueva lista
		foreach t "nodos elementos" {
		    set _lista_ogl($t,id) [ drawopengl draw -genlists 1]
		}

		# creamos la lista para los nodos
		drawopengl draw -newlist $_lista_ogl(nodos,id) compile
	    
		# primero pinto los nodos gorditos
		drawopengl draw -pointsize 3.0
		drawopengl draw -begin points 
		for { set i 0} { $i < $n} { incr i} {
		    set idx [ lindex $lst_idx_puntos $i]
		    drawopengl draw -vertex $puntos($idx)
		}
		drawopengl draw -end
		drawopengl draw -pointsize 1.0
		# fin de la lista
		drawopengl draw -endlist

		# creamos la lista para los nodos
		drawopengl draw -newlist $_lista_ogl(elementos,id) compile

		foreach que_mesh $lst_que_elementos {
		    # "Point Linear Triangle Quadrilateral Tetrahedra Hexahedra Prisma"
		    set tipo [ lindex $que_mesh 0]
		    set nnodos [ lindex $que_mesh 1] 
		    if { $tipo == "point"} {
			continue
		    } else {
			drawopengl draw -begin lines 
			if { $tipo == "linear" } {
			    if { $nnodos == 2} {
				foreach elem $MESH($que_mesh) {
				    foreach idx $elem {
					drawopengl draw -vertex $puntos($idx)
				    }
				}
			    } else {
				foreach elem $MESH($que_mesh) {
				    set n1 [ lindex $elem 0]
				    set n2 [ lindex $elem 1]
				    set n3 [ lindex $elem 2]
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n2)
				}
			    }

			} elseif { $tipo == "triangle" } {
			    if { $nnodos == 3} {
				foreach elem $MESH($que_mesh) {
				    set n1 [ lindex $elem 0]
				    set n2 [ lindex $elem 1]
				    set n3 [ lindex $elem 2]
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n1)
				}
			    } else { # 6 nodos
				foreach elem $MESH($que_mesh) {
				    set n1 [ lindex $elem 0]
				    set n2 [ lindex $elem 1]
				    set n3 [ lindex $elem 2]
				    set n4 [ lindex $elem 3]
				    set n5 [ lindex $elem 4]
				    set n6 [ lindex $elem 5]
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n5)
				    drawopengl draw -vertex $puntos($n5)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n6)
				    drawopengl draw -vertex $puntos($n6)
				    drawopengl draw -vertex $puntos($n1)
				}
			    }

			} elseif { $tipo == "quadrilateral" } {
			    if { $nnodos == 4} {
				foreach elem $MESH($que_mesh) {
				    set n1 [ lindex $elem 0]
				    set n2 [ lindex $elem 1]
				    set n3 [ lindex $elem 2]
				    set n4 [ lindex $elem 3]
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n1)
				}
			    } else { # 8 o 9 nodos
				foreach elem $MESH($que_mesh) {
				    set n1 [ lindex $elem 0]
				    set n2 [ lindex $elem 1]
				    set n3 [ lindex $elem 2]
				    set n4 [ lindex $elem 3]
				    set n5 [ lindex $elem 4]
				    set n6 [ lindex $elem 5]
				    set n7 [ lindex $elem 6]
				    set n8 [ lindex $elem 7]
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n5)
				    drawopengl draw -vertex $puntos($n5)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n6)
				    drawopengl draw -vertex $puntos($n6)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n7)
				    drawopengl draw -vertex $puntos($n7)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n8)
				    drawopengl draw -vertex $puntos($n8)
				    drawopengl draw -vertex $puntos($n1)
				}
			    }

			} elseif { $tipo == "tetrahedra" } {
			    if { $nnodos == 4} {
				foreach elem $MESH($que_mesh) {
				    set n1 [ lindex $elem 0]
				    set n2 [ lindex $elem 1]
				    set n3 [ lindex $elem 2]
				    set n4 [ lindex $elem 3]
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n3)
				}
			    } else { # 10 nodos
				foreach elem $MESH($que_mesh) {
				    set n1 [ lindex $elem 0]
				    set n2 [ lindex $elem 1]
				    set n3 [ lindex $elem 2]
				    set n4 [ lindex $elem 3]
				    set n5 [ lindex $elem 4]
				    set n6 [ lindex $elem 5]
				    set n7 [ lindex $elem 6]
				    set n8 [ lindex $elem 7]
				    set n9 [ lindex $elem 8]
				    set n10 [ lindex $elem 9]
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n5)
				    drawopengl draw -vertex $puntos($n5)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n6)
				    drawopengl draw -vertex $puntos($n6)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n7)
				    drawopengl draw -vertex $puntos($n7)
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n8)
				    drawopengl draw -vertex $puntos($n8)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n9)
				    drawopengl draw -vertex $puntos($n9)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n10)
				    drawopengl draw -vertex $puntos($n10)
				    drawopengl draw -vertex $puntos($n3)
				}
			    }

			} elseif { $tipo == "hexahedra" } {
			    if { $nnodos == 8} {
				foreach elem $MESH($que_mesh) {
				    set n1 [ lindex $elem 0]
				    set n2 [ lindex $elem 1]
				    set n3 [ lindex $elem 2]
				    set n4 [ lindex $elem 3]
				    set n5 [ lindex $elem 4]
				    set n6 [ lindex $elem 5]
				    set n7 [ lindex $elem 6]
				    set n8 [ lindex $elem 7]
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n5)
				    drawopengl draw -vertex $puntos($n6)
				    drawopengl draw -vertex $puntos($n6)
				    drawopengl draw -vertex $puntos($n7)
				    drawopengl draw -vertex $puntos($n7)
				    drawopengl draw -vertex $puntos($n8)
				    drawopengl draw -vertex $puntos($n8)
				    drawopengl draw -vertex $puntos($n5)
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n5)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n6)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n7)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n8)
				}
			    } else { # 20 o 27 nodos
				foreach elem $MESH($que_mesh) {
				    set n1 [ lindex $elem 0]
				    set n2 [ lindex $elem 1]
				    set n3 [ lindex $elem 2]
				    set n4 [ lindex $elem 3]
				    set n5 [ lindex $elem 4]
				    set n6 [ lindex $elem 5]
				    set n7 [ lindex $elem 6]
				    set n8 [ lindex $elem 7]
				    set n9 [ lindex $elem 8]
				    set n10 [ lindex $elem 9]
				    set n11 [ lindex $elem 10]
				    set n12 [ lindex $elem 11]
				    set n13 [ lindex $elem 12]
				    set n14 [ lindex $elem 13]
				    set n15 [ lindex $elem 14]
				    set n16 [ lindex $elem 15]
				    set n17 [ lindex $elem 16]
				    set n18 [ lindex $elem 17]
				    set n19 [ lindex $elem 18]
				    set n20 [ lindex $elem 19]
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n9)
				    drawopengl draw -vertex $puntos($n9)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n10)
				    drawopengl draw -vertex $puntos($n10)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n11)
				    drawopengl draw -vertex $puntos($n11)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n12)
				    drawopengl draw -vertex $puntos($n12)
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n5)
				    drawopengl draw -vertex $puntos($n17)
				    drawopengl draw -vertex $puntos($n17)
				    drawopengl draw -vertex $puntos($n6)
				    drawopengl draw -vertex $puntos($n6)
				    drawopengl draw -vertex $puntos($n18)
				    drawopengl draw -vertex $puntos($n18)
				    drawopengl draw -vertex $puntos($n7)
				    drawopengl draw -vertex $puntos($n7)
				    drawopengl draw -vertex $puntos($n19)
				    drawopengl draw -vertex $puntos($n19)
				    drawopengl draw -vertex $puntos($n8)
				    drawopengl draw -vertex $puntos($n8)
				    drawopengl draw -vertex $puntos($n20)
				    drawopengl draw -vertex $puntos($n20)
				    drawopengl draw -vertex $puntos($n5)
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n13)
				    drawopengl draw -vertex $puntos($n13)
				    drawopengl draw -vertex $puntos($n5)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n14)
				    drawopengl draw -vertex $puntos($n14)
				    drawopengl draw -vertex $puntos($n6)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n15)
				    drawopengl draw -vertex $puntos($n15)
				    drawopengl draw -vertex $puntos($n7)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n16)
				    drawopengl draw -vertex $puntos($n16)
				    drawopengl draw -vertex $puntos($n8)
				}
			    }

			} elseif { $tipo == "prisma" } {
			    if { $nnodos == 6} {
				foreach elem $MESH($que_mesh) {
				    set n1 [ lindex $elem 0]
				    set n2 [ lindex $elem 1]
				    set n3 [ lindex $elem 2]
				    set n4 [ lindex $elem 3]
				    set n5 [ lindex $elem 4]
				    set n6 [ lindex $elem 5]
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n5)
				    drawopengl draw -vertex $puntos($n5)
				    drawopengl draw -vertex $puntos($n6)
				    drawopengl draw -vertex $puntos($n6)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n5)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n6)
				}
			    } else { # 15 nodos
				foreach elem $MESH($que_mesh) {
				    set n1 [ lindex $elem 0]
				    set n2 [ lindex $elem 1]
				    set n3 [ lindex $elem 2]
				    set n4 [ lindex $elem 3]
				    set n5 [ lindex $elem 4]
				    set n6 [ lindex $elem 5]
				    set n7 [ lindex $elem 6]
				    set n8 [ lindex $elem 7]
				    set n9 [ lindex $elem 8]
				    set n10 [ lindex $elem 9]
				    set n11 [ lindex $elem 10]
				    set n12 [ lindex $elem 11]
				    set n13 [ lindex $elem 12]
				    set n14 [ lindex $elem 13]
				    set n15 [ lindex $elem 14]
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n7)
				    drawopengl draw -vertex $puntos($n7)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n8)
				    drawopengl draw -vertex $puntos($n8)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n9)
				    drawopengl draw -vertex $puntos($n9)
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n13)
				    drawopengl draw -vertex $puntos($n13)
				    drawopengl draw -vertex $puntos($n5)
				    drawopengl draw -vertex $puntos($n5)
				    drawopengl draw -vertex $puntos($n14)
				    drawopengl draw -vertex $puntos($n14)
				    drawopengl draw -vertex $puntos($n6)
				    drawopengl draw -vertex $puntos($n6)
				    drawopengl draw -vertex $puntos($n15)
				    drawopengl draw -vertex $puntos($n15)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n1)
				    drawopengl draw -vertex $puntos($n10)
				    drawopengl draw -vertex $puntos($n10)
				    drawopengl draw -vertex $puntos($n4)
				    drawopengl draw -vertex $puntos($n2)
				    drawopengl draw -vertex $puntos($n11)
				    drawopengl draw -vertex $puntos($n11)
				    drawopengl draw -vertex $puntos($n5)
				    drawopengl draw -vertex $puntos($n3)
				    drawopengl draw -vertex $puntos($n12)
				    drawopengl draw -vertex $puntos($n12)
				    drawopengl draw -vertex $puntos($n6)
				}
			    }
			} else {
			    WarnWinText "Unknow element type: $tipo with $nnodos nodes"
			}
			drawopengl draw -end
		    }
		}

		# fin de la lista de elementos
		drawopengl draw -endlist
		
		set _id_func_ogl [ drawopengl register ::MiguelPruebas::PintarLista]
		
		unset lst_idx_puntos
		unset lst_que_elementos
		unset MESH
		unset puntos
	    }
	    EndWaitState
	}
    }
}

proc MyWarnWin { msg } {
    tk_messageBox -message "$msg" -icon warning -type ok
}

proc MyNewBarShowHelp { } {
    MyWarnWin "help [ lindex [.central.s info Project] 4]"
}

proc MyNewBarProc { { what DEFAULT} { img_dir ""}} {
    global MyNewBarBitmapsNames MyNewBarBitmapsCommands MyNewBarBitmapsHelp
    global MyNewBarImgDir

    set MyNewBarBitmapsNames(0) "new.gif open2.gif save.gif --- help.gif"
    
    set MyNewBarBitmapsCommands(0) [ list {-np- MyWarnWin new} {-np- MyWarnWin read} {-np- MyWarnWin save} "" \
					 {-np- MyNewBarShowHelp} ]
    set MyNewBarBitmapsHelp(0) [ list "New" "Open" "Save" "" "Help status"]

    CreateOtherBitmaps MyNewBar "My new Bar" MyNewBarBitmapsNames MyNewBarBitmapsCommands \
	MyNewBarBitmapsHelp "$::MyNewBarImgDir" MyNewBarBitmaps $what PrePost

    AddNewToolbar "My new bar" PrePostMyNewBarWindowGeom MyNewBarProc "My new bar title"
}
	
proc InitGIDProject { dir} {
    global MyNewBarImgDir

    set MyNewBarImgDir [ file join $dir imagenes]
    ::MiguelPruebas::Ini $dir
 
    CreateMenu "MiguelPruebas" "PREPOST"
    InsertMenuOption "MiguelPruebas" "Read ASCII mesh" 0 "::MiguelPruebas::LeerMalla" "PREPOST"
    InsertMenuOption "MiguelPruebas" "Colour nodes" 1 "::MiguelPruebas::CambiaColor nodos" "PREPOST"
    InsertMenuOption "MiguelPruebas" "Colour elements" 2 "::MiguelPruebas::CambiaColor elementos" "PREPOST"
    UpdateMenus
    
    #Create a new toolbar
    MyNewBarProc

    source [file join $dir gidutils.tcl]
}

proc EndGIDProject { } {
    ::MiguelPruebas::End
}