proc EditNURBS { LineOrSurface } {
    global GidPriv
    set w .gid.nurbsurfmove
    set GidPriv(FixBoundary) 1
    set GidPriv(Decrement) 0.4
    set GidPriv(LastDecrement) 0.4
    set GidPriv(FixBoundary) 1
    if { ![info exists GidPriv(EdNURBStolerance)] } { 
	set GidPriv(EdNURBStolerance) [_ "Automatic"]
    } elseif {$GidPriv(EdNURBStolerance)==-1.0} {
	set GidPriv(EdNURBStolerance) [_ "Automatic"]
    }

    set entitytypename [_ $LineOrSurface]
    InitWindow $w [_ "Edit NURBS %s" $entitytypename] EditNURBSWindowGeom
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0
    frame $w.frmMovement 
    label $w.frmMovement.lblMoveType -text [_ "Movement type"]
    
    if { ![info exists GidPriv(Movement)] } {
	set GidPriv(Movement) MoveScreen
    }
    if { $LineOrSurface == "surface" } {
	set labels [list [_ "Screen"] [_ "Normal"] [_ "Point"] [_ "X-Axis"] [_ "Y-Axis"] [_ "Z-Axis"]]
	set commands { MoveScreen MoveNormal MoveToPoint MoveXAxis MoveYAxis MoveZAxis }
    } else {
	set labels [list [_ "Screen"] [_ "Point"] [_ "X-Axis"] [_ "Y-Axis"] [_ "Z-Axis"]]
	set commands { MoveScreen MoveToPoint MoveXAxis MoveYAxis MoveZAxis }
    }
    ComboBoxRAM $w.frmMovement.mnuMovement GidPriv(Movement) $labels $commands
    
    GidHelp "$w.frmMovement.mnuMovement" \
	[_ "User can choose the mode of select points dinamically."]
    
    frame $w.frmDecrement -borderwidth 2 -relief ridge
    
    button $w.buttonMinus -text - -disabledforeground grey60 
    
    scale $w.sclDecrement -from 0 -to 1 -resolution 0.05 -showvalue 1 \
	    -highlightbackground black \
	    -orient horizontal \
	    -label [_ "Influence factor"] -variable GidPriv(Decrement)
    

    button $w.buttonPlus -text + -disabledforeground grey60 \
	    
    
    GidHelp "$w.sclDecrement" \
	[_ "Value 0 only move the control point\n value 1 move all control points."]
    
    checkbutton $w.chkFixBoundary -text [_ "Fix boundary"] \
	    -variable GidPriv(FixBoundary) \
	    -command EditNurbSetBoundary
    
    GidHelp "$w.chkFixBoundary" [_ "Fix or free the boundary control points."]
    
    
    frame $w.frmLineSpecific
    frame $w.frmSurfaceSpecific
    button $w.btnInsertKnot -text [_ "Insert knot"] -command {GiD_Process InsertKnot} \
	    -disabledforeground grey60 -width 16
    button $w.btnDegreeElevate -text [_ "Elevate degree"] -command {GiD_Process DegreeElevate} \
	    -disabledforeground grey60 -width 16
    button $w.btnDegreeReduce -text [_ "Reduce degree"] -command {SendTolAnd DegreeReduce} \
	    -disabledforeground grey60 -width 16
    
    button $w.btnWeightChange -text [_ "Change weight"] -command {GiD_Process WeightChange} \
	    -disabledforeground grey60 -width 16
    button $w.btnCancelWeights -text [_ "Cancel weights"] -command {GiD_Process CancelWeights} \
	    -disabledforeground grey60 -width 16

    button $w.btnReparametrize -text [_ "Reparametrize"] -command {GiD_Process Reparametrize} \
	    -disabledforeground grey60 -width 16
    button $w.btnSimilarCubic -text [_ "Similar Cubic"] -command {SendTolAnd SimilarCubic} \
	    -disabledforeground grey60 -width 16

    button $w.btnInsertUKnot -text [_ "Insert U knot"] -command {GiD_Process InsertUKnot} \
	    -disabledforeground grey60 -width 16
    button $w.btnInsertVKnot -text [_ "Insert V knot"] -command {GiD_Process InsertVKnot} \
	    -disabledforeground grey60 -width 16
    button $w.btnDegreeUElevate -text [_ "Elevate U degree"] -command {GiD_Process DegreeUElevate} \
	    -disabledforeground grey60 -width 16
    button $w.btnDegreeVElevate -text [_ "Elevate V degree"] -command {GiD_Process DegreeVElevate} \
	    -disabledforeground grey60 -width 16
    button $w.btnDegreeUReduce -text [_ "Reduce U degree"] -command {SendTolAnd DegreeUReduce } \
	    -disabledforeground grey60 -width 16
    button $w.btnDegreeVReduce -text [_ "Reduce V degree"] -command {SendTolAnd DegreeVReduce} \
	    -disabledforeground grey60 -width 16

    button $w.btnKnotRemoval -text [_ "Knot Removal"] -command {SendTolAnd KnotRemoval} \
	    -disabledforeground grey60 -width 16
    button $w.btnUKnotRemoval -text [_ "Knot Removal in U"] -command {SendTolAnd UKnotRemoval} \
	    -disabledforeground grey60 -width 16
    button $w.btnVKnotRemoval -text [_ "Knot Removal in V"] -command {SendTolAnd VKnotRemoval} \
	    -disabledforeground grey60 -width 16

    label $w.labeltol -text [_ "Tolerance"]: -disabledforeground grey60 -width 16

    entry $w.entrytol -textvariable GidPriv(EdNURBStolerance) -relief sunken -width 16

    set def_back [$w cget -background]

    frame $w.frmButtons -bg [CCColorActivo $def_back]
    button $w.frmButtons.btnApply -text [_ "Apply"] \
	-command [list EditNurbCmdApply $w $LineOrSurface] \
	    -underline 0 -width 8

    button $w.frmButtons.btnSelect -text [_ "Pick"] \
	-underline 0 \
	-command [list EditNurbSelEntity $w $LineOrSurface] -width 8
   
    button $w.frmButtons.btnclose -text [_ "Close"] \
	-command [list EditNurbClose $w $LineOrSurface] \
	-underline 0 -width 8

    SetWidgetsWidthFromText $w.frmButtons.btnApply $w.frmButtons.btnSelect $w.frmButtons.btnclose

    grid $w.frmMovement -row 1 -column 1 -pady 5
    grid $w.frmMovement.lblMoveType -row 1 -column 1
    grid $w.frmMovement.mnuMovement -row 1 -column 2

    grid $w.frmDecrement -row 2 -column 1 -columnspan 2 -padx 6 -sticky ew
    grid $w.buttonMinus -in $w.frmDecrement -row 1 -column 1 
    grid $w.sclDecrement -in $w.frmDecrement -row 1 -column 2 -sticky ew
    grid $w.buttonPlus -in $w.frmDecrement -row 1 -column 3 
    grid columnconfigure $w.frmDecrement 2 -weight 1

    grid $w.chkFixBoundary -row 3 -column 1

    if { $LineOrSurface == "surface" } {
	grid $w.frmSurfaceSpecific -row 4 -column 1 -padx 5 -pady 5 
	grid $w.btnInsertUKnot -in $w.frmSurfaceSpecific -row 1 -column 1
	grid $w.btnUKnotRemoval -in $w.frmSurfaceSpecific -row 1 -column 2
	grid $w.btnInsertVKnot -in $w.frmSurfaceSpecific -row 2 -column 1
	grid $w.btnVKnotRemoval -in $w.frmSurfaceSpecific -row 2 -column 2
	grid $w.btnDegreeUElevate -in $w.frmSurfaceSpecific -row 3 -column 1
	grid $w.btnDegreeUReduce -in $w.frmSurfaceSpecific -row 3 -column 2
	grid $w.btnDegreeVElevate -in $w.frmSurfaceSpecific -row 4 -column 1
	grid $w.btnDegreeVReduce -in $w.frmSurfaceSpecific -row 4 -column 2
	grid $w.btnWeightChange -in $w.frmSurfaceSpecific -row 5 -column 1
	grid $w.btnCancelWeights -in $w.frmSurfaceSpecific -row 5 -column 2
	grid $w.btnReparametrize -in $w.frmSurfaceSpecific -row 6 -column 1
	grid $w.btnSimilarCubic -in $w.frmSurfaceSpecific -row 6 -column 2
	grid $w.labeltol -in $w.frmSurfaceSpecific -row 7 -column 1
	grid $w.entrytol -in $w.frmSurfaceSpecific -row 7 -column 2 
    } else {
	grid $w.frmLineSpecific -row 4 -column 1 -padx 5 -pady 5 
	grid $w.btnInsertKnot -in $w.frmLineSpecific -row 1 -column 1
	grid $w.btnKnotRemoval -in $w.frmLineSpecific -row 1 -column 2
	grid $w.btnDegreeElevate -in $w.frmLineSpecific -row 2 -column 1
	grid $w.btnDegreeReduce -in $w.frmLineSpecific -row 2 -column 2
	grid $w.btnWeightChange -in $w.frmLineSpecific -row 3 -column 1
	grid $w.btnCancelWeights -in $w.frmLineSpecific -row 3 -column 2
	grid $w.btnReparametrize -in $w.frmLineSpecific -row 4 -column 1
	grid $w.btnSimilarCubic -in $w.frmLineSpecific -row 4 -column 2
	grid $w.labeltol -in $w.frmLineSpecific -row 5 -column 1
	grid $w.entrytol -in $w.frmLineSpecific -row 5 -column 2 
    }

   
    grid $w.frmButtons.btnApply -row 1 -column 1 -padx 5 -pady 6
    grid $w.frmButtons.btnSelect -row 1 -column 2 -padx 5 -pady 6
    grid $w.frmButtons.btnclose -row 1 -column 3 -padx 5 -pady 6
    grid $w.frmButtons -row 5 -column 1  -sticky ews -columnspan 7
    if { $::tcl_version >= 8.5 } { grid anchor $w.frmButtons center }

    # Resize behavior management
    grid columnconf $w 1 -minsize 80 -weight 1

    grid rowconfigure $w 1 -weight 0
    grid rowconfigure $w 2 -weight 0
    grid rowconfigure $w 3 -weight 0
    grid rowconfigure $w 4 -weight 0
    grid rowconfigure $w 5 -weight 2

    set GidPriv(auxvar) $w.sclDecrement
    $w.buttonMinus conf -command { $GidPriv(auxvar) set [expr $GidPriv(Decrement)-0.05] }

    $w.buttonPlus conf -command { $GidPriv(auxvar) set [expr $GidPriv(Decrement)+0.05] }

    $w.sclDecrement conf -command EditNurbDecrementMoving

    EnabledDisabled $w $LineOrSurface disabled

    focus $w.frmButtons.btnSelect

    bind $w <Alt-s> "tkButtonInvoke $w.frmButtons.btnSelect"
    bind $w <Alt-c> "tkButtonInvoke $w.frmButtons.btnclose"
    bind $w <Escape> "tkButtonInvoke $w.frmButtons.btnclose"
    bind $w <Return> "tkButtonInvoke $w.frmButtons.btnApply"

    bind $w <Destroy> [list +DestroyEditNURBS %W $w]
    trace add variable GidPriv(Movement) write "EditNurbsChangeMovement ;#"
}

proc EditNurbDecrementMoving { val } {
    global GidPriv
    if { $val != $GidPriv(LastDecrement) } {
	set GidPriv(LastDecrement) $val
	GiD_Process Decrement=$val 
    }
}

proc EditNurbSetBoundary { } {
    global GidPriv
    if { $GidPriv(FixBoundary) } {
	GiD_Process FixBoundary
    } else {
	GiD_Process FreeBoundary
    }
}

proc EditNurbCancelPick { w LineOrSurface } {
    GiD_Process MEscape
    $w.frmButtons.btnSelect conf -command [list EditNurbSelEntity $w $LineOrSurface] -text [_ "Pick"]
    SetWidgetsWidthFromText $w.frmButtons.btnSelect
}

proc EditNurbClose { w LineOrSurface } {
    if { $LineOrSurface == "surface" } {
	GiD_Process MEscape Geometry Edit EdNurbsSurf Close 
    } else { 
	GiD_Process MEscape Geometry Edit EdNurbsLine Close 
    }  
    if { [winfo exists $w] } { destroy $w }
}

proc EditNurbSelEntity { w LineOrSurface } {
    $w.frmButtons.btnSelect conf -command [list EditNurbCancelPick $w $LineOrSurface] -text [_ "Cancel"]  
    if { $LineOrSurface == "surface" } {
	set nnum [GidUtils::PickEntities Surfaces single]
    } else { 
	set nnum [GidUtils::PickEntities Lines single]
    }
   
    $w.frmButtons.btnSelect conf -command [list EditNurbCmdBreak $w $LineOrSurface] -text [_ "Cancel"]

    if { $nnum != "" } {
	set entitytypename [_ $LineOrSurface]    
	wm title $w [_ "Edit NURBS %s %d" $entitytypename $nnum]
	
	set GidPriv(selection) ""
	
	EnabledDisabled $w $LineOrSurface normal
	if { $LineOrSurface == "surface" } {
	    GiD_Process MEscape geometry edit EdNurbsSurf $nnum
	} else {
	    GiD_Process MEscape geometry edit EdNurbsLine $nnum
	}
	after idle [list delayedop changefunc "EnabledDisabled $w $LineOrSurface disabled"]
    }
}


proc EditNurbCmdApply { w LineOrSurface } {
    GiD_Process escape
    #EnabledDisabled $w $LineOrSurface disabled
    EditNurbSelEntity $w $LineOrSurface
}

proc EditNurbCmdBreak { w LineOrSurface } {
    GiD_Process Break
    $w.frmButtons.btnSelect conf -command [list EditNurbSelEntity $w $LineOrSurface] -text [_ "Pick"]
}
 

proc EnabledDisabled { w LineOrSurface stat } { 
    $w.frmMovement.mnuMovement conf -state $stat
    $w.sclDecrement conf -state $stat 
    if { $stat == "disabled" } {
	set entitytypename [_ "%s" $LineOrSurface]
	wm title $w [_ "Edit NURBS %s" $entitytypename]
	$w.frmButtons.btnSelect conf -command [list EditNurbSelEntity $w $LineOrSurface] -text [_ "Pick"]
	$w.sclDecrement conf -fg grey60 
    } else { 
	$w.sclDecrement conf -fg black
    }
    $w.buttonMinus conf -state $stat
    $w.buttonPlus conf -state $stat
    $w.chkFixBoundary conf -state $stat
    if { $LineOrSurface == "surface" } {
	#RecursiveChangeState $w.frmSurfaceSpecific $stat 
	$w.btnInsertUKnot conf -state $stat
	$w.btnInsertVKnot conf -state $stat
	$w.btnUKnotRemoval conf -state $stat
	$w.btnVKnotRemoval conf -state $stat
	$w.btnDegreeUElevate conf -state $stat
	$w.btnDegreeVElevate conf -state $stat
	$w.btnDegreeUReduce conf -state $stat
	$w.btnDegreeVReduce conf -state $stat
	$w.btnWeightChange conf -state $stat
	$w.btnCancelWeights conf -state $stat
	$w.btnReparametrize conf -state $stat
	$w.btnSimilarCubic conf -state $stat
	$w.labeltol conf -state $stat
    } else {
	#RecursiveChangeState $w.frmLineSpecific $stat 
	$w.btnInsertKnot conf -state $stat
	$w.btnKnotRemoval conf -state $stat
	$w.btnDegreeElevate conf -state $stat
	$w.btnDegreeReduce conf -state $stat
	$w.btnWeightChange conf -state $stat
	$w.btnCancelWeights conf -state $stat
	$w.btnReparametrize conf -state $stat
	$w.btnSimilarCubic conf -state $stat        
	$w.labeltol conf -state $stat
    }
    $w.frmButtons.btnApply conf -state $stat
}

proc DestroyEditNURBS { W w } {
    if { $W != $w } return
    global GidPriv
    trace remove variable GidPriv(Movement) write "EditNurbsChangeMovement ;#"
}

proc EditNurbsChangeMovement { } {
    global GidPriv
    if { ![info exists GidPriv(Movement)] } {
	set GidPriv(Movement) MoveScreen
    }
    GiD_Process $GidPriv(Movement)
}
     
proc SendTolAnd { value } {
    global GidPriv
    if { $GidPriv(EdNURBStolerance)==[_ "Automatic"] } {
	GiD_Process Tolerance -1.0 $value
    } else {
	GiD_Process Tolerance $GidPriv(EdNURBStolerance) $value
    }
}