
set PCR_ResultadosAgrupados 1

proc CreaMenuAnalisisPaso { w cmd_in} {
    global GidPriv RMenuRPriv

    rmenuinit
    set all_anal [lsort -dictionary [GiD_Info postprocess get all_analisis]]
    # set all_anal [ GiD_Info postprocess get all_analisis]
    set cur_anal [ GiD_Info postprocess get cur_analisis]
    
    $w del 0 end

    set cur_step [ GiD_Info postprocess get cur_step $cur_anal] 

    if { $all_anal == ""} {
	$w add command -label [_ "Please load a MODEL first"] -state disabled
	return
    }

    foreach i $all_anal {
	regsub -all {_} [= $i] { } menu_txt
	regsub -all {\.} $i {_} menu_name

	$w add cascade -label $menu_txt -menu $w.m$menu_name -compound left

	set all_step [ GiD_Info postprocess get all_steps $i]
	set cur_step [ GiD_Info postprocess get cur_step $i] 
	if { [ winfo exists $w.m$menu_name ]} {
	    $w.m$menu_name del 0 end
	} else {
	    menu $w.m$menu_name
	}
	set words ""

	set entrada_ventana 0
	if { ( [ llength $all_step] > $RMenuRPriv(MaxAbsolute)) && ( $RMenuRPriv(MaxAbsolute) > 2)} {
	    set all_step [ lrange $all_step 0 [ expr $RMenuRPriv(MaxAbsolute) - 2]]
	    set entrada_ventana 1
	}

	foreach j $all_step {
	    if { ( $cur_anal != $i) || ( $cur_step != $j) } {
		lappend words [ list $j "$cmd_in $i $j"]
	    } else {
		lappend words [ list $j "$cmd_in $i $j" check]
	    }
	}
	rmenuconf $w.m$menu_name $words

	if { $entrada_ventana} {
	    $w.m$menu_name add separator
	    $w.m$menu_name add command -label ...[_ "More"]... -command PostGeom::Create
	}
    }
}

proc ActualizaTextoAnalisis { w args} {
    global PCRPriv
    set PCRPriv(analisis) [ lindex $args 0]
    set PCRPriv(paso) [ lindex $args 1]
    regsub -all {_} [= $PCRPriv(analisis)] { } txt_a
    $w conf -text "   $txt_a / $PCRPriv(paso)   "
}

proc PCRSelectAnalStep { w text_id} {
    global PCRPriv

    if { ![ winfo exists $w.m]} {
	menu $w.m 
    }
    CreaMenuAnalisisPaso $w.m "ActualizaTextoAnalisis $text_id"
    $w.m post [ winfo pointerx $w] [ winfo pointery $w]
}

proc CreaMenuResultadosNodales { w cmd_in} {
    global GidPriv RMenuRPriv


    # sin componentes
    # los de Result_Surface son resultados nodales
    set que_res "Result_Surface"

    rmenuinit
    set all_anal [lsort -dictionary [ GiD_Info postprocess get all_analisis]]
    # set all_anal [ GiD_Info postprocess get all_analisis]
    if { $all_anal == ""} {
	set msg [_ "Please load a MODEL first"]
    } else {
	set msg [_ "Please select a STEP first"]
    }
    set cur_anal [ GiD_Info postprocess get cur_analisis]
    if { $cur_anal == ""} { 
	$w del 0 end  
	$w add command -label $msg -state disabled
	return
    }

    set cur_step [ GiD_Info postprocess get cur_step $cur_anal] 
    if { $cur_step == ""} { 
	$w add command -label [_ "Please select a STEP first"] -state disabled
	$w del 0 end
	return
    }

    if { $que_res != "Deformation" } {
	set all_res [ GiD_Info postprocess get cur_results_list $que_res ]
    } else {
	set all_res [ GiD_Info postprocess get show_geom_all_deform $cur_anal \
	    $cur_step ]
    }
    if { $all_res == ""} { 
	$w del 0 end
	$w add command -label [_ "No useful results found"] -state disabled
	return
    }

    $w del 0 end

    if { $que_res != "Deformation" } {
	set cur_res [ GiD_Info postprocess get cur_result]
	set cur_comp [ GiD_Info postprocess get cur_component]
    } else {
	set cur_res [ GiD_Info postprocess get main_geom_cur_deform]
	set cur_comp ""
    }
    
    set entrada_ventana 0
    if { [ llength $all_res] > $RMenuRPriv(MaxNumCol)} {
	set all_res [ lrange $all_res 0 [ expr $RMenuRPriv(MaxNumCol) - 2]]
	set entrada_ventana 1
    }

    foreach i $all_res {

	set wm [ GetResultMenuFromPath $w $i ""]

	regsub -all {_} [= $i] { } txt
	if { $wm != $w} {    
	    if { [ regexp {^/?/?(.*)//(.*?)$} $i dum path res_txt]} {
		regsub -all {_} [= $res_txt] { } txt
	    }
	}

	$wm add command -label $txt -command "$cmd_in $i" -compound left
	
    }

    if { $entrada_ventana} {
	$w add separator
	$w add command -label ...[_ "More"]... -command PostGeom::Create
    }

}

proc ActualizaTextoResultado1 { w args} {
    global PCRPriv
    set PCRPriv(resultado1) [ lindex $args 0]

    regsub -all {_} [= $PCRPriv(resultado1)] { } txt
    if { [ regexp {^/?/?(.*)//(.*?)$} $PCRPriv(resultado1) dum path res_txt]} {
	regsub -all {_} [= $res_txt] { } txt
    }
    $w conf -text "   $txt   "
}

proc PCRSelectResult1 { w text_id} {
    global PCRPriv

    if { ![ info exists PCRPriv(analisis)] || ![ info exists PCRPriv(paso)]} {
	WarnWin [_ "Please, select an analysis and a step first."] $w
	return
    }

    GiD_Process escape escape escape escape results analysissel $PCRPriv(analisis) $PCRPriv(paso)

    # los de Result_Surface son resultados nodales
    if { ![ winfo exists $w.m]} {
	menu $w.m 
    }
    CreaMenuResultadosNodales $w.m "ActualizaTextoResultado1 $text_id"
    $w.m post [ winfo pointerx $w] [ winfo pointery $w]
}

proc ActualizaTextoResultado2 { w args} {
    global PCRPriv
    set PCRPriv(resultado2) [ lindex $args 0]

    regsub -all {_} [= $PCRPriv(resultado2)] { } txt
    if { [ regexp {^/?/?(.*)//(.*?)$} [= $PCRPriv(resultado2)] dum path res_txt]} {
	regsub -all {_} $res_txt { } txt
    }
    $w conf -text "   $txt   "
}


proc PCRSelectResult2 { w text_id} {
    global PCRPriv

    if { ![ info exists PCRPriv(analisis)] || ![ info exists PCRPriv(paso)]} {
	WarnWin [_ "Please, select an analysis and a step first."] $w
	return
    }

    GiD_Process escape escape escape escape results analysissel "$PCRPriv(analisis)" $PCRPriv(paso)

    # los de Result_Surface son resultados nodales
    if { ![ winfo exists $w.m]} {
	menu $w.m 
    }
    CreaMenuResultadosNodales $w.m "ActualizaTextoResultado2 $text_id"
    $w.m post [ winfo pointerx $w] [ winfo pointery $w]
}

proc CreaMenuOperadores { w cmd_in} {
    global GidPriv RMenuRPriv

    rmenuinit
    set all_operadores "+ - * /"
    
    $w del 0 end
    foreach i $all_operadores {
	regsub -all {_} $i { } txt
	$w add command -label $txt -command "$cmd_in $i" -compound left
    }
}

proc ActualizaTextoOperacion { w args} {
    global PCRPriv
    set PCRPriv(operador) [ lindex $args 0]
    $w conf -text "   $PCRPriv(operador)   "
}

proc PCRSelectOperacion { w text_id} {
    global PCRPriv
    
    if { ![ winfo exists $w.m]} {
	menu $w.m 
    }
    CreaMenuOperadores $w.m "ActualizaTextoOperacion $text_id"
    $w.m post [ winfo pointerx $w] [ winfo pointery $w]
}

proc PCRApply { } {
    global PCRPriv

    foreach d "analisis paso resultado1 operador resultado2 ResultadoDestino" \
	txt "Analysis Step {First Result} Operator {Second Result} {Result destination name}" \
	txt_trad [_ "Analysis Step {First Result} Operator {Second Result} {Result destination name}"] {
	    if { ![ info exists PCRPriv($d)]} {
		set txt1 [_ "Please, choose a correct '"]
		append txt1 $txt_trad"'"
		WarnWin "$txt1" $PCRPriv(wid)
		return
	    }
	}

    set err [ catch {
	set res_info1 [ GiD_Result get [ list $PCRPriv(ResultadoDestino) $PCRPriv(analisis) $PCRPriv(paso)]]
    } errtxt ]
    if { !$err} {
 	set resp [ tk_dialog  $PCRPriv(wid).___pa_ww [_ "Warning"] \
		       [ format [_ "Result '%s' already exists. Delete it?"] $PCRPriv(ResultadoDestino)] \
 		       error 1 [_ "Yes, delete it"] [_ "No, leave it"]]
 	switch $resp {
 	    0 {
 		GiD_Result delete [ list $PCRPriv(ResultadoDestino) $PCRPriv(analisis) $PCRPriv(paso)]
		GidUtils::SetWarnLine [_ "Result '%s' deleted" $PCRPriv(ResultadoDestino)]
 	    }
 	    1 {
 		return
 	    }
 	}
    }

    #$PCRPriv(chivato) conf -text "Processing ..."

    set err [ catch {
	set res_info1 [ GiD_Result get [ list $PCRPriv(resultado1) $PCRPriv(analisis) $PCRPriv(paso)]]
    } errtxt ]
    if { $err} {
	WarnWin [ format [_ "Result '%s' does not exist: %s"] $PCRPriv(resultado1) $errtxt] $PCRPriv(wid)
	return
    }
    set err [ catch {
	set res_info2 [ GiD_Result get [ list $PCRPriv(resultado2) $PCRPriv(analisis) $PCRPriv(paso)]]
    } errtxt ]
    if { $err} {
	WarnWin [ format [_ "Result '%s' does not exist: %s"] $PCRPriv(resultado2) $errtxt] $PCRPriv(wid)
	return
    }

    # monto la cabecera
    # regsub -all { } "$PCRPriv(ResultadoDestino)" {_} dst_txt
    # set cabecera [ lindex $res_info1 0]
    # if { ![ regsub -all "$PCRPriv(resultado1)" $cabecera $dst_txt dst_cab]} {
    # 	regsub -all {_} "$PCRPriv(resultado1)" { } tmp
    # 	set res [ regsub -all "$tmp" "$cabecera" "$dst_txt" dst_cab]
    # }
    # 
    # set res_dst [ list $dst_cab]
    
    regsub -all { } $PCRPriv(ResultadoDestino) {_} dst_txt
    set cabecera [ lindex $res_info1 0]
    set res_dst [ list "Result [ list $PCRPriv(ResultadoDestino)] [ lrange $cabecera 2 end]"]

    # me salto las cabeceras
    set res_info1 [ lrange $res_info1 1 end]
    set res_info2 [ lrange $res_info2 1 end]
    
    set max_idx 0

    # creo el array del primer resultado
    foreach r1 $res_info1 {
	set idx [ lindex $r1 0]
	if { ![ regexp {[0-9]+} $idx]} {
	    # si no es un indice, nos lo saltamos
	    # WarnWin "r1: No es un indice $idx"
	    continue
	}
	if { $idx > $max_idx} { set max_idx $idx}
	if { $::PCR_ResultadosAgrupados} {
	    set res [ lindex $r1 1]
	} else {
	    set res [ lrange $r1 1 end]
	}
	set resultado1(n_comp) [ llength $res]
	for { set ic 0 } { $ic < $resultado1(n_comp)} { incr ic} {
	    set resultado1($idx,$ic) [ lindex $res $ic]
	}
    }
    # creo el array del segundo resultado
    foreach r2 $res_info2 {
	set idx [ lindex $r2 0]
	if { ![ regexp {[0-9]+} $idx]} {
	    # si no es un indice, nos lo saltamos
	    # WarnWin "r2: No es un indice $idx"
	    continue
	}
	if { $idx > $max_idx} { set max_idx $idx}
	if { $::PCR_ResultadosAgrupados} {
	    set res [ lindex $r2 1]
	} else {
	    set res [ lrange $r2 1 end]
	}
	set resultado2(n_comp) [ llength $res]
	for { set ic 0 } { $ic < $resultado2(n_comp)} { incr ic} {
	    set resultado2($idx,$ic) [ lindex $res $ic]
	}
    }

    unset res_info1
    unset res_info2

    if { $resultado1(n_comp) != $resultado2(n_comp)} {
	WarnWin [_ "Different number of components, please check the results selected"] $PCRPriv(wid)
	return
    }

    if { $resultado1(n_comp) > 6} { 
	set resultado1(n_comp) 6
	set resultado2(n_comp) 6
    } elseif { $resultado1(n_comp) == 4} { 
	set resultado1(n_comp) 3
	set resultado2(n_comp) 3
    }
    
    #$PCRPriv(chivato) conf -text "Processing node 0 of $max_idx"
    set n_chivato 0

    for { set i 1} { $i <= $max_idx} { incr i} {
	if { ![ info exists resultado1($i,0)]} {
	    WarnWinText [ format [_ "result index %d does not exists for result '%s'. skipping it"] \
			  [ expr $i + 1] $PCRPriv(resultado1)] $PCRPriv(wid)
	    continue
	}
	if { ![ info exists resultado2($i,0)]} {
	    WarnWinText [ format [_ "result index %d does not exists for result '%s'. skipping it"] \
			  [ expr $i + 1] $PCRPriv(resultado2)] $PCRPriv(wid)
	    continue
	}
	set dstres $i
	#set lstres {}
	for { set ic 0 } { $ic < $resultado1(n_comp)} { incr ic} {
	    set res [ expr $resultado1($i,$ic) $PCRPriv(operador) $resultado2($i,$ic)]
	    #lappend lstres $res
	    lappend dstres $res
	}
	#lappend dstres $lstres
	lappend res_dst $dstres

        incr n_chivato
	if { $n_chivato == 1000} {
	    # $PCRPriv(chivato) conf -text "Processing node $i of $max_idx"
	    # set n_chivato 0
	    set ::progressbar::var [ expr int( ( 100.0 * $i) / $max_idx)]
	    update idletasks
	    update
	}
    }
    set ::progressbar::var 100
    #$PCRPriv(chivato) conf -text "Done"
    #after 3000 "$PCRPriv(chivato) conf -text {}"
    after 3000 set ::progressbar::var 0

    eval [ concat GiD_Result create $res_dst]
    GidUtils::SetWarnLine [_ "Result '%s' created" $PCRPriv(ResultadoDestino)]

    unset resultado1
    unset resultado2
    unset res_dst

    if { [ regexp {([^0-9]*)([0-9]+)$} $PCRPriv(ResultadoDestino) dum raiz num]} {
	set nuevo_nombre "$raiz[ expr $num + 1]"
    } else {
	set nuevo_nombre "$PCRPriv(ResultadoDestino) 2"
    }
    set PCRPriv(ResultadoDestino) $nuevo_nombre
}

proc PCRClose { } {
    global PCRPriv
    destroy $PCRPriv(wid)
}

proc PCRIniVariables { } {
    global PCRPriv
    foreach d "analisis paso resultado1 operador resultado2 ResultadoDestino" {
	if { [ info exists PCRPriv($d)]} {
	    unset PCRPriv($d)
	}
    }
}

proc PCRBorrarResultado { } {
    global PCRPriv

    if { ![ info exists PCRPriv(analisis)] || ![ info exists PCRPriv(paso)]} {
	WarnWin [_ "Please, select an analysis and a step first."] $PCRPriv(wid)
	return
    }

    set err [ catch {
	set res_info1 [ GiD_Result get [ list $PCRPriv(ResultadoDestino) $PCRPriv(analisis) $PCRPriv(paso)]]
    } errtxt ]
    if { $err} {
	WarnWin [ format [_ "Result '%s' does not exist: %s"] $PCRPriv(ResultadoDestino) $errtxt] $PCRPriv(wid)
	return
    }

    if { ![ llength $res_info1] || ( [ lindex $res_info1 0] == "GiD_Result:")} {
	if { [ llength $res_info1]} {
	    WarnWin $res_info1 $PCRPriv(wid)
	} else {
	    WarnWin [ format [_ "Result '%s' does not exists."] $PCRPriv(ResultadoDestino)] $PCRPriv(wid)
	}
    }

    if { [ llength $res_info1] && ( [ lindex $res_info1 0] != "GiD_Result:")} {
	set resp [ tk_dialog  $PCRPriv(wid).___pa_ww [_ "Warning"] \
 		       [ format [_ "Do you really want to delete the Result '%s'?"] $PCRPriv(ResultadoDestino)] \
 		       error 1 [_ "Yes, delete it"] [_ "No, leave it"]]
 	switch $resp {
 	    0 {
 		GiD_Result delete [ list $PCRPriv(ResultadoDestino) $PCRPriv(analisis) $PCRPriv(paso)]
		GidUtils::SetWarnLine [_ "Result '%s' deleted" $PCRPriv(ResultadoDestino)]
 	    }
 	    1 {
 		return
 	    }
 	}
    }
}

proc PostCreateResult { { w .gid.wPostCrearResultado}} {
    global PCRPriv GidPriv GIDDEFAULT

    PCRIniVariables

    InitWindow $w [_ "Create Result in Tcl"] PostCreareResultWindowGeom PostCreateResult
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0

    set PCRPriv(wid) $w
    
    set color_fondo [ CCGetRGB $w [ $w cget -background]]
    set color_sel [ CCColorSombra $color_fondo 65]
    set color_realzado [ CCColorActivo $color_fondo]


    set f [ frame $w.f -border 2 -relief ridge]

    set f0 [ frame $w.f0 -border 0]
    label $f0.l -text [_ "Analysis & step"]
    button $f0.b -text [_ "Select analysis & step"] -command [ list PCRSelectAnalStep $w $f0.b]
    grid $f0.l $f0.b -sticky news

    set f1 [ frame $w.f1 -border 0]
    label $f1.l -text [_ "Result 1"]:
    button $f1.b -text [_ "Select result"] -command [ list PCRSelectResult1 $w $f1.b]
    grid $f1.l $f1.b -sticky news

    set f2 [ frame $w.f2 -border 0]
    label $f2.l -text [_ "Operator"]:
    button $f2.b -text [_ "Select operator"] -command [ list PCRSelectOperacion $w $f2.b]
    grid $f2.l $f2.b -sticky news

    set f3 [ frame $w.f3 -border 0]
    label $f3.l -text [_ "Result 2"]:
    button $f3.b -text [_ "Select result"] -command [ list PCRSelectResult2 $w $f3.b]
    grid $f3.l $f3.b -sticky news

    set fr [ frame $w.fr -border 0]
    label $fr.l -text [_ "Result name"]:
    entry $fr.e -textvariable PCRPriv(ResultadoDestino) -width 20
    
    set archivo "erase-cross.gif"
    button $fr.b -image [GetImage $archivo] -command PCRBorrarResultado

    #label $fr.l2 -text ""
    ::progressbar::progressbar $fr.l2 -variable ::progressbar::var \
	-width 200 -background $color_fondo
    set ::progressbar::var 0

    grid $fr.l $fr.e $fr.b -sticky news
    grid $fr.l2 -sticky news -columnspan 3
    set PCRPriv(ResultadoDestino) [_ "New result"]
    
    set PCRPriv(chivato) $fr.l2
    

    grid $f0 -sticky news
    grid $f1 -sticky news
    grid $f2 -sticky news
    grid $f3 -sticky news
    grid $fr -sticky news
    if { $::tcl_version >= 8.5 } { 
	grid anchor $f0 center 
	grid anchor $f1 center 
	grid anchor $f2 center 
	grid anchor $f3 center 
	grid anchor $fr center 
    }

    grid columnconfigure $f 0 -weight 1
    grid rowconfigure $f 0 -weight 1
    grid rowconfigure $f 1 -weight 1
    grid rowconfigure $f 2 -weight 1
    grid rowconfigure $f 3 -weight 1
    grid rowconfigure $f 4 -weight 1
    
    # marco de los botones
    frame $w.but -bd 0 -background $color_realzado
    
    button $w.but.apply -text [_ "Apply"] -command PCRApply -takefocus 1 -bd 1
    button $w.but.close -text [_ "Close"] -command PCRClose -takefocus 1 -bd 1

    SetWidgetsWidthFromText $w.but.apply $w.but.close

    grid $w.but.apply -sticky ews -padx 4 -pady 10
    grid $w.but.close -sticky ews -padx 4 -pady 10 -row 0 -column 1

#     proc create_result {} {
# 	set txt [ GiD_Result get_nodes]
# 	foreach in $txt {
# 	    WarnWinText $in
# 	}
# 	return
# 	set anal [lindex [ GiD_Info postprocess get all_analysis] 0]
# 	set step [lindex [ GiD_Info postprocess get all_steps $anal] 0]
# 	set res [lindex [ GiD_Info postprocess get results_list Contour_Fill $anal $step] 0]
# 	set data [ GiD_Result get [ list $res $anal $step]]
# 	#WarnWin [ lindex $data 0]
# 	
# 	#lset data 0 1 "[lindex $data 0 1] 2"
# 	lset data 0 1 resnew
# 	set len [llength $data]
# 	for { set i 1 } { $i < $len } { incr i } {
# 	    for { set j 0 } { $j < 4 } { incr j } {
# 		lset data $i 1 $j [expr {[lindex $data $i 1 $j]*2.0}]
# 	    }
# 	    lset data $i [ join [ lindex $data $i]]
# 	}
# 	set ret [eval GiD_Result create $data]
# 	tk_messageBox -message $ret
#     }
#     button $w.but.pp -text "pp" -command create_result -takefocus 1 -bd 1
#     grid $w.but.pp -sticky ews -padx 4 -pady 10 -row 0 -column 2

    #enpaquetamos marcos
    grid $w.f -sticky news -padx 0 -pady 0
    grid $w.but -sticky wes
    if { $::tcl_version >= 8.5 } { grid anchor $w.but center }

    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 1
    focus $w.but.apply
    bind $w <Return> "tkButtonInvoke $w.but.apply"  
    bind $w <Alt-c> "tkButtonInvoke $w.but.close"
    bind $w <Escape> "tkButtonInvoke $w.but.close"

    update idletasks

}

########################################################################

namespace eval PCreateResult {
    variable _wid
    variable _lst_variables   {}
    variable _widget_variables
    variable _txt_analisis
    variable _analisis
    variable _paso

    variable _txt_analisis
    variable _analisis
    variable _paso
    variable _txt_resultado
    variable _resultado
    variable _txt_componente
    variable _componente
    variable _txt_variable
    variable _lst_variables
}

# package requirements
package require tablelist_tile

proc PCreateResult::EsLista { var} {
    set idx [ string first \{ $var]
    set es_lista 0
    # miramos si hay el primer 
    if { $idx != -1 } {
	if { $idx == 0} {
	    set es_lista 1
	} elseif { [ string index $var [ expr $idx - 1]] != "\\"} {
	    set es_lista 1
	}
    }
    if { $es_lista} {
	# ahora si hay algo que lo cierra:
	set idx [ string first \} $var $idx]
	if { $idx == -1} {
	    set es_lista 0
	}
    }
    return $es_lista
}

proc PCreateResult::QuitaSubrallados { lst { es_lista 0}} {
    set txt_lst {}
    if { !$es_lista} {
	regsub -all {_} $lst { } txt_lst
    } else {
	foreach elem $lst {
	    regsub -all {_} $elem { } txt
	    lappend txt_lst $txt
	}
    }
    return $txt_lst
}

proc PCreateResult::PonSubrallados { lst { es_lista 0}} {
    set txt_lst {}
    if { !$es_lista} {
	regsub -all { } $lst {_} txt_lst
    } else {
	foreach elem $lst {
	    regsub -all { } $elem {_} txt
	    lappend txt_lst $txt
	}
    }
    return $txt_lst
}

proc PCreateResult::Aplica { } {
    variable _wid
    #destroy $_wid
}

proc PCreateResult::Cierra { } {
    variable _wid
    destroy $_wid
}

proc PCreateResult::ActualizaListaAnalisis { w} {
    variable _txt_analisis
    variable _analisis

    $w configure -values [ QuitaSubrallados [ lsort -dictionary [ GiD_Info postprocess get all_analisis]] 1]
}

proc PCreateResult::ActualizaListaPasos { w} {
    variable _txt_analisis
    variable _analisis
    variable _paso

    if { $_txt_analisis == "" } { return}
    set _analisis [ PonSubrallados $_txt_analisis 0]

    if { $_analisis != ""} {
	set all_steps [ GiD_Info postprocess get all_steps $_analisis]
	$w configure -values $all_steps
	set analisis_actual [ GiD_Info postprocess get cur_analisis]
	if { $analisis_actual == $_analisis} {
	    set paso_actual [ GiD_Info postprocess get cur_step $analisis_actual]
	} else {
	    set paso_actual [ lindex $all_steps 0]
	}
	set _paso $paso_actual
    }
}


proc PCreateResult::Get_Resultados {} {
    set ret {}
    set all [ GiD_Info postprocess get cur_results_list "Result_Surface" ]
    foreach res $all {
	lappend ret $res
    }
    return $ret
}

proc PCreateResult::ActualizaListaResultados { w wc} {
    variable _analisis
    variable _paso
    variable _txt_resultado
    variable _resultado

    if { $_analisis == ""} { return }
    if { $_paso == ""} { return}

    set ret [ GiD_Info postprocess get results_list "Result_Surface"  $_analisis $_paso]
    $w configure -values [ QuitaSubrallados $ret 1]
    if { [ lsearch $ret $_txt_resultado] == -1} {
	if { [ llength $ret] != 0} {
	    set _resultado [ lindex $ret 0]
	} else {
	    set _resultado ""
	}
	regsub -all {_} $_resultado { } _txt_resultado
	ActualizaListaComponentes $wc
    }
}

proc PCreateResult::ActualizaListaComponentes { w} {
    variable _txt_resultado
    variable _analisis
    variable _paso
    variable _resultado
    variable _txt_componente

    if { $_analisis == ""} { return }
    if { $_paso == ""} { return}

    if { $_txt_resultado == ""} { return }
    set _resultado [ PonSubrallados $_txt_resultado 0]

    set ret [ GiD_Info postprocess get components_list "Result_Surface" \
		  $_resultado $_analisis $_paso]
    $w configure -values [ QuitaSubrallados $ret 1]
    if { [ lsearch $ret $_txt_componente] == -1} {
	if { [ llength $ret] != 0} {
	    set _txt_componente [ lindex $ret 0]
	} else {
	    set _txt_componente ""
	}
	ActualizaNombreComponente
    }
}

proc PCreateResult::ActualizaNombreComponente { } {
    variable _txt_componente
    variable _componente

    if { $_txt_componente == ""} { return}
    set _componente [ PonSubrallados $_txt_componente 0]
    
}

proc PCreateResult::ValidaNombre { nombre_var} {
    upvar $nombre_var var
    # nombre de variables validas: 
    # comienzan por letra 
    # y les siguen letras, numeros, y alguno de los siguientes caracteres
    # _ # ! + - * / % & ' 
    # \#!+-*/%&'
    set valida 0
    if { [ regexp {^([[:alpha:]][\w\#!+\-*/%&\']+)$} $var dum pepe]} {
	set valida 1
    }
    return $valida
}

proc PCreateResult::ValidaVariableYCierra { w nombre_ant} {
    variable _txt_variable

    if { ![ ValidaNombre PCreateResult::_txt_variable]} {
	WarnWin [ concat [_ "Invalid variable name. \
	    \nShould begin with a letter and followed\
	    \nby a digit, letter or"] " \# ! + - * / % & '"] $w
	return
    } else {
	
    }

    if { $nombre_ant != ""} {
	# quitamos $nombre_ant
    }
    
    # anyadimos la nueva variable a la lista
    destroy $w
}

proc PCreateResult::VentanaEditaVariable { { w .gid.wPCreateResultEditaVariable} { nombre ""}} {
    variable _txt_analisis
    variable _analisis
    variable _paso
    variable _txt_resultado
    variable _resultado
    variable _txt_componente
    variable _componente
    variable _txt_variable
    variable _lst_variables

    if { [ winfo exists $w]} { 
	raise $w
	return
    }

    InitWindow $w [_ "Add variable"] PostEditaVariableWindowGeom \
	PCreateResult::VentanaEditaVariable
    if { ![ winfo exists $w]} return
    
    ATTK frame $w.f -bd 0

    if { $nombre == ""} {
	set _txt_variable [_ "No_Name"]_[ llength _lst_variables]
    } else {
	set _txt_variable $nombre
    }

    ATTK label $w.f.lv -text [_ "Variable name"]:
    ATTK entry $w.f.ev -textvariable PCreateResult::_txt_variable -width 30 -bd 1

    ATTK label $w.f.la -text [_ "Analysis"]:
    ATTK ComboBox $w.f.ma -textvariable PCreateResult::_txt_analisis -editable 0 -width 30 -bd 1 \
	-modifycmd [ list PCreateResult::ActualizaListaPasos $w.f.fp.mp]
    
    ATTK label $w.f.lp -text [_ "Step"]:
    ATTK ComboBox $w.f.mp -textvariable PCreateResult::_paso -editable 0 -width 8 -bd 1 \
	-modifycmd [ list PCreateResult::ActualizaListaResultados $w.f.m1 $w.f.m2]

    ATTK label $w.f.l1 -text [_ "Result"]:
    ATTK ComboBox $w.f.m1 -textvariable PCreateResult::_txt_resultado -editable 0 -width 30 -bd 1 \
	-modifycmd [ list PCreateResult::ActualizaListaComponentes $w.f.m2]

    ATTK label $w.f.l2 -text [_ "Component"]:
    ATTK ComboBox $w.f.m2 -textvariable PCreateResult::_txt_componente -editable 0 -width 30 -bd 1 \
	-modifycmd PCreateResult::ActualizaNombreComponente

    # rellenamos los widget con valores
    ActualizaListaAnalisis $w.f.ma

    set _analisis [ GiD_Info postprocess get cur_analisis]
    regsub -all {_} $_analisis { } _txt_analisis
	    
    ActualizaListaPasos $w.f.mp
    $w.f.m1 configure -values [ PCreateResult::Get_Resultados]
    ActualizaListaResultados $w.f.m1 $w.f.m2

    # nombre variable
    grid $w.f.lv $w.f.ev -sticky e -padx 2 -pady 1
    grid configure $w.f.ev -sticky ew
    # analisis
    grid $w.f.la $w.f.ma -sticky e -padx 2 -pady 1
    grid configure $w.f.ma -sticky ew
    # paso
    grid $w.f.lp $w.f.mp -sticky e -padx 2 -pady 1
    grid configure $w.f.mp -sticky w
    # resultado
    grid $w.f.l1 $w.f.m1 -sticky e -padx 2 -pady 1
    grid configure $w.f.m1 -sticky ew
    # componente
    grid $w.f.l2 $w.f.m2 -sticky e -padx 2 -pady 1
    grid configure $w.f.m2 -sticky ew

    grid rowconfigure $w.f 0 -weight 1
    grid rowconfigure $w.f 1 -weight 1
    grid rowconfigure $w.f 2 -weight 1
    grid rowconfigure $w.f 3 -weight 1
    grid rowconfigure $w.f 4 -weight 1
    grid columnconfigure $w.f 0 -weight 1
    grid columnconfigure $w.f 1 -weight 1
        
    set def_back [ $w cget -background]
    frame $w.buts -bg [ CCColorActivo $def_back]

    button $w.buts.apply -text [_ "Create"] -command \
	[ list PCreateResult::ValidaVariableYCierra $w $nombre]
    button $w.buts.close -text [_ "Cancel"] -command [ list destroy $w]

    SetWidgetsWidthFromText $w.buts.apply $w.buts.close
    
    grid $w.buts.apply $w.buts.close -sticky ew -padx 5 -pady 6
    
    # parte superior
    grid $w.f -sticky nsew
    # parte inferior
    grid $w.buts -sticky sew
    if { $::tcl_version >= 8.5 } { grid anchor $w.buts center }
    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 1
    
    bind $w <Escape> "tkButtonInvoke $w.buts.close"


    tkwait window $w

    set ret_val ""
    if { ( $_txt_analisis != "") && ( $_paso != "") && \
	     ( $_txt_resultado != "") && ( $_txt_componente != "")} {
	set ret_val [ list $_txt_variable Scalar Result \
			  $_txt_analisis $_paso $_txt_resultado $_txt_componente]
    }
    return $ret_val
}

proc PCreateResult::AnyadeVariable { lista} {
    set w $lista.def

    set info_var [ VentanaEditaVariable $w]
    if { [ winfo exists $lista]} {
	if { $info_var != ""} {
	    $lista insert end $info_var
	}
    }
}

proc PCreateResult::QuitaVariable { lista} {
    WarnWin "Aade variable"
}

proc PCreateResult::CreaListaVariables { f} {
    variable _widget_variables

    set _widget_variables $f.list

    ATTK frame $f -bd 0
    ATTK scrollbar $f.xscroll -relief sunken -orient horizontal \
	-command [ list $f.list xview] \
	-bd 1 -elementborderwidth 1 
    ATTK scrollbar $f.yscroll -relief sunken -orient vertical \
	-command [ list $f.list yview] \
		-bd 1 -elementborderwidth 1
    ATTK listbox $f.list -height 5 -width 20 \
	-xscroll [ list $f.xscroll set] \
	-yscroll [ list $f.yscroll set] \
	-selectmode browse -relief sunken -bd 1
	
    grid $f.list -sticky ewns
    grid $f.xscroll -sticky ew
    grid $f.yscroll -sticky ns -rowspan 2 -row 0 -column 1
    grid rowconfigure $f 0 -weight 1
    grid columnconfigure $f 0 -weight 1
    return $f
}

proc PCreateResult::EventosWidgetVariables { f add_cmd del_cmd edit_cmd} {
    variable _widget_variables

    bind $_widget_variables <Double-Button-1> $edit_cmd
    bind $_widget_variables <Return> $edit_cmd
    bind $_widget_variables <Delete> $del_cmd
    bind $_widget_variables <Insert> $add_cmd
    bind $_widget_variables <plus> $add_cmd
    bind $_widget_variables <minus> $del_cmd
    #bind $_widget <KeyPress> "WarnWin %K"
}

proc PCreateResult::CreaTablaVariables { f} {
    global GidPriv
    variable _widget_variables

    ATTK frame $f -bd 0

    # nombre de la tabla
    set tbl $f.tbl
    set _widget_variables $f.tbl

    ATTK scrollbar $f.xscroll -relief sunken -orient horizontal \
	-bd 1 -elementborderwidth 1 \
	-command [ list $tbl xview]
    ATTK scrollbar $f.yscroll -relief sunken -orient vertical \
	-bd 1 -elementborderwidth 1 \
	-command [ list $tbl yview]
    ATTK tablelist::tablelist $tbl -exportselection 0 \
	-columns [ list \
		       10 [_ "Name"] left \
		       5 [_ "Type"] left \
		       5 [_ "Class"] left \
		       15 [_ "Analysis"] left \
		       4 [_ "Step"] left \
		       15 [_ "Result"] left \
		       15 [_ "Component"] left \
		       ] \
	-selectbackground black \
	-selectforeground white \
	-background $GidPriv(Color,BackgroundListbox) \
	-stretch all \
	-selectmode single \
	-labelborderwidth 1 \
	-labelcommand tablelist::sortByColumn \
	-labelpady 0 \
	-showarrow 1 \
	-showseparators 0 \
	-xscrollcommand [ list $f.xscroll set] \
	-yscrollcommand [ list $f.yscroll set] \
	-resizablecolumns 1 \
	-stripebackground [ CCColorSombra $GidPriv(Color,BackgroundListbox)] \
	-activestyle frame \
	-selecttype row
	#-highlightthickness 0
	
    # for { set i 0} { $i < 7} { incr i} {
    # 	$tbl columnconfigure $i -selectbackground $GidPriv(Color,BackgroundListbox) \
    # 	    -selectforeground black
    # }

    grid $f.tbl -sticky ewns
    grid $f.xscroll -sticky ew
    grid $f.yscroll -sticky ns -rowspan 2 -row 0 -column 1
    grid rowconfigure $f 0 -weight 1
    grid columnconfigure $f 0 -weight 1
    return $f
}

proc PCreateResult::Crear { { w .gid.wPostCrearResultado2}} {
    variable _wid
    variable _widget_variables

    PCRIniVariables

    InitWindow $w [_ "Create Result in Tcl"] PostCreateResultWindowGeom PCreateResult::Crear
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0

    set _wid $w
    
    set color_fondo [ CCGetRGB $w [ $w cget -background]]
    set color_sel [ CCColorSombra $color_fondo 65]
    set color_realzado [ CCColorActivo $color_fondo]

    ATTK frame $w.ventana -bd 0 
    # -relief ridge

    # lista de variables
    #TitleFrame $w.ventana.lv -text [_ "Variable list"]
    #set f [ $w.ventana.lv getframe]
    set f [ ATTK labelframe $w.ventana.lv \
		-text [_ "Variable list"]]

    #CreaListaVariables $f.lb
    CreaTablaVariables $f.lb

    # control de lista de variables: mas menos y edit
    ATTK frame $f.bot -bd 0
    ATTK button $f.bot.mas -image [ GetImage Mas16.gif] -bd 1 \
	-command [ list PCreateResult::AnyadeVariable $_widget_variables]
    ATTK button $f.bot.edit -text [_ "Edit"] -bd 1 \
	-command [ list WarnWin "edita variable"]
    ATTK button $f.bot.menos -image [ GetImage Menos16.gif] -bd 1 \
	-command [ list PCreateResult::QuitaVariable $_widget_variables]

    grid $f.bot.mas $f.bot.edit $f.bot.menos -sticky w -padx 4 -pady 2
    grid rowconfigure $f.bot 0 -weight 1

    EventosWidgetVariables $f.lb \
	[ $f.bot.mas cget -command] [ $f.bot.menos cget -command] [ $f.bot.edit cget -command]
    
    grid $f.lb -sticky nsew -padx 4 -pady 2
    grid $f.bot -sticky ew
    grid rowconfigure $f 0 -weight 1
    grid columnconfigure $f 0 -weight 1

    # texto con las formulas
    # TitleFrame $w.ventana.tf -text [_ "Formula"]
    # set f [ $w.ventana.tf getframe]
    set f [ ATTK labelframe $w.ventana.tf -text [_ "Formula"]]

    ATTK frame $f.tt -bd 0
    ATTK scrollbar $f.tt.xscroll -relief sunken -orient horizontal \
	-command "$f.tt.text xview" \
	-bd 1 -elementborderwidth 1 
    ATTK scrollbar $f.tt.yscroll -relief sunken -orient vertical \
	-command "$f.tt.text yview" \
		-bd 1 -elementborderwidth 1
    ATTK text $f.tt.text -width 20 -height 5 \
	-xscroll "$f.tt.xscroll set" \
	-yscroll "$f.tt.yscroll set" \
	-relief sunken -bd 1

    grid $f.tt.text -sticky ewns
    grid $f.tt.xscroll -sticky ew
    grid $f.tt.yscroll -sticky ns -rowspan 2 -row 0 -column 1
    grid rowconfigure $f.tt 0 -weight 1
    grid columnconfigure $f.tt 0 -weight 1
    
    grid $f.tt -sticky news -padx 4 -pady 2
    grid rowconfigure $f 0 -weight 1
    grid columnconfigure $f 0 -weight 1


    grid $w.ventana.lv -sticky news -padx 2
    grid $w.ventana.tf -sticky news -padx 2
    grid rowconfigure $w.ventana 0 -weight 1
    grid rowconfigure $w.ventana 1 -weight 1
    grid columnconfigure $w.ventana 0 -weight 1

    # apply y close
    # marco de los botones
    ATTK frame $w.but -bd 0 -background $color_realzado
    
    ATTK button $w.but.apply -text [_ "Apply"] -command PCreateResult::Aplica \
	-takefocus 1 -bd 1
    ATTK button $w.but.close -text [_ "Close"] -command PCreateResult::Cierra \
	-takefocus 1 -bd 1

    # SetWidgetsWidthFromText $w.but.apply $w.but.close

    grid $w.but.apply -sticky ews -padx 4 -pady 10
    grid $w.but.close -sticky ews -padx 4 -pady 10 -row 0 -column 1

    #enpaquetamos marcos
    grid $w.ventana -sticky news 
    ATTK frame $w.sep -bd 0 -height 4 -relief flat

    #-pady 4 -padx 4
    grid $w.sep -sticky we
    grid $w.but -sticky wes
    if { $::tcl_version >= 8.5 } { grid anchor $w.but center }

    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 1
    bind $w <Return> "+$w.but.apply configure -relief sunken; \
	    update; \
	    $w.but.apply invoke; \
	    $w.but.apply configure -relief raised"
    bind $w <Escape> "focus $w.but.close; \
	    $w.but.close configure -relief sunken; \
	    $w.but.close invoke"
    
    update idletasks
}
