
proc pref_format_ui {base args} {
    global ChangeVarInfo
	
    set f [ttk::labelframe $base.gf -text [_ "Generic format"]]
    ttk::label $f.l1 -text [_ "Real format (Tcl)"]:
    ttk::entry $f.e1 -textvariable ChangeVarInfo(RealFormat,Default)
    GidHelp "$f.l1 $f.e1" [_ "Numeric format used for example when showing coordinates \
	    (see general preferences, display coordinates)"]
    
    grid $f.l1 $f.e1 -padx 4 -pady 2 -ipadx 2 -sticky e
    grid conf $f.e1 -sticky ew
    grid rowconfigure $f 0 -weight 1
    grid columnconfigure $f 1 -weight 1
    
    set f [ttk::labelframe $base.rf -text [_ "Results format"]]
    ttk::label $f.l1 -text [_ "Legend format"]:
    ttk::entry $f.e1 -textvariable ChangeVarInfo(PostLegendFormat)
    ttk::label $f.l2 -text [_ "Scalar label format"]:
    entry $f.e2 -bd 1 -textvariable ChangeVarInfo(PostScalarFormat)
    ttk::label $f.l3 -text [_ "Vector label format"]:
    ttk::entry $f.e3 -textvariable ChangeVarInfo(PostVectorFormat)
    ttk::label $f.l4 -text [_ "Matrix label format"]:
    ttk::entry $f.e4 -textvariable ChangeVarInfo(PostMatrixFormat)
    ttk::label $f.l5 -text [_ "Default real format"]:
    ttk::entry $f.e5 -textvariable ChangeVarInfo(PostDefaultRealFormat)
    GidHelp "$f.l1 $f.e1" [_ "Numeric format used to print postprocess legends"]
    GidHelp "$f.l2 $f.e2" [_ "Numeric format used to print postprocess scalar results"]
    GidHelp "$f.l3 $f.e3" [_ "Numeric format used to print postprocess vector results"]
    GidHelp "$f.l5 $f.e5" [_ "Numeric format used by default for other real values"]
    
    grid $f.l1 $f.e1 -padx 4 -pady 2 -ipadx 2 -sticky e
    grid conf $f.e1 -sticky ew
    grid $f.l2 $f.e2 -padx 4 -pady 2 -ipadx 2 -sticky e
    grid conf $f.e2 -sticky ew
    grid $f.l3 $f.e3 -padx 4 -pady 2 -ipadx 2 -sticky e
    grid conf $f.e3 -sticky ew
    grid $f.l4 $f.e4 -padx 4 -pady 2 -ipadx 2 -sticky e
    grid conf $f.e4 -sticky ew
    grid $f.l5 $f.e5 -padx 4 -pady 2 -ipadx 2 -sticky e
    grid conf $f.e5 -sticky ew
    
    grid rowconfigure $f 4 -weight 1
    grid columnconfigure $f 1 -weight 1
    
    grid $base.gf -sticky new -padx 2 -pady 2
    grid $base.rf -sticky new -padx 2 -pady 2
    
    grid rowconfigure $base 1 -weight 1
    grid columnconfigure $base 0 -weight 1
    
    set ChangeVarInfo(BasePostWin) $base
}

